/*
 * float2str.c
 *
 *  Created on: 2014-10-22
 *      Author: HuJin
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *float2str(char *out_str, int len, char *format, double f)
{
	char	str[128];
	int		i, j;

	snprintf(str, len+1, format, f);

	for (i = len, j = strlen(str); j >= 0; i--, j--)
		out_str[i] = str[j];

	for (; i >= 0; i--)
		out_str[i] = '0';

	out_str[len+1] = 0;

	return out_str;
}

