#include "config.h"
#include <stdio.h>
#include <math.h>
#include "assert_demos.h"

int main()
{
	printf("\n\r");
	printf(">>> demo printf: start <<<\n\r");
	printf("if you see all messages in UPPER case, then nds_write() is overridden!\n\r");
	printf("=== demo printf: end ===\n\r");

	double d1 = sin(1 + 0.1);
	double d2 = sin(1 + 0.3);
	unsigned int i1 = 12345678;
	unsigned int i2 = 9876345;
	char buf1[300];
	char temp1[20];
	char temp2[20];

	sprintf (buf1,"/%d %2d %s /%s\r\n", i1,i2, float2str(temp1, 8, "%05.2f", d1),float2str(temp2, 13, "%08.4f", d2));
	printf("string is %s\n",buf1);

	while (1) ;
}

/*
 * override putchar
 */
#include "config.h"
#if defined(CFG_AG102)
#include "ag102.h"
#elif defined(CFG_AE210P)
#include "ae210p.h"
#else
#include "ag101p.h"
#endif

#include <ctype.h> /* for toupper() */

#undef putchar
inline int putchar(int c)
{
	c = toupper(c);

	/* tx fifo full */
	while ((inw(UART_BASE + UART_LSR_OFFSET) & 0x20) == 0);
	outw(UART_BASE + UART_THR_OFFSET, c);
	return c;
}

void nds_write(const unsigned char *buf, int size)
{
	int    i;
	for (i = 0; i < size; i++)
		putchar(buf[i]);
}
